UNIT UCicn;

INTERFACE

USES
	UMacApp, Fonts, UList, UPrinting, UGridView, Errors, Resources, ToolUtils;

TYPE
{==============================}
	TCicnApplication = OBJECT(TApplication)
		Procedure TCicnApplication.ICicnApplication;
		Function TCicnApplication.DoMakeDocument(itsCmdNumber :
							CmdNumber) : TDocument; OVERRIDE;
	End;

{==============================}
	TCicnDocument = OBJECT(TDocument)
		fSaveIcon : Boolean;
		fSaveIcl4 : Boolean;
		fSaveIcl8 : Boolean;
		fSaveIcs : Boolean;
		fSaveIcs4 : Boolean;
		fSaveIcs8 : Boolean;
		fCicnList	: TList;
		fCicnView : TCicnView;
		Procedure TCicnDocument.ICicnDocument;
		Procedure TCicnDocument.DoSetupMenus; OVERRIDE;
		Function  TCicnDocument.DoMenuCommand(aCmdNumber : CmdNumber) :
																					TCommand; OVERRIDE;
		Procedure TCicnDocument.AddCicnLast(aCicn : TCicn);
		Procedure TCicnDocument.DeleteCicn(aCicn : TCicn);
		Function  TCicnDocument.CicnAt(theIndex : Integer) : TCicn;
		Procedure TCicnDocument.DoMakeViews(forPrinting : boolean); OVERRIDE;
		Procedure TCicnDocument.ForEachCicnDo(Procedure Something(aCicn : TCicn));
		Procedure TCicnDocument.Free; OVERRIDE;
		Procedure TCicnDocument.FreeData; OVERRIDE;
		Procedure TCicnDocument.DoNeedDiskSpace(VAR dataForkBytes, 
							rsrcForkBytes : LongInt); OVERRIDE;
		Procedure TCicnDocument.DoWrite(aRefNum : integer; makingCopy :
							Boolean); OVERRIDE;
		Procedure TCicnDocument.DoRead(aRefNum : integer; rsrcExists, 
							forPrinting : Boolean); OVERRIDE;
		{$IFC qDebug}
		Procedure TCicnDocument.Fields(Procedure DoToField(
							fieldName : Str255; fieldAddr : Ptr; fieldType :
							integer)); OVERRIDE;
		{$ENDC}
		End;

{==============================}
	TCicnView = OBJECT(TGridView)
		fCicnDocument : TCicnDocument;
		Procedure TCicnView.IRes(itsDocument : TDocument; itsSuperView : TView;
														Var itsParams : Ptr); OVERRIDE;
		Procedure TCicnView.DrawCell(aCell : GridCell; aQDRect : Rect); OVERRIDE;
		{$IFC qDebug}
			Procedure TCicnView.Fields(Procedure DoToField(
								fieldName : Str255; fieldAddr : Ptr; fieldType :
								integer)); OVERRIDE;
		{$ENDC}
	End;

{==============================}
	TCicn = OBJECT(TObject)
		fId : INTEGER;
		fName : Str255;
		fCicnHandle : CIconHandle;
		fCicnDocument : TCicnDocument;
		Procedure TCicn.ICicn(aCicnDocument : TCicnDocument);
		Procedure TCicn.DrawCicn(theRect : Rect);
		Procedure TCicn.RemoveOldResources(id : Integer);
		Procedure TCicn.WriteResources(aRefNum : Integer);
		Function TCicn.ExtractRsrc(theDepth : Integer; halfSize : Boolean) : Handle;
		Function TCicn.ExtractMask(halfSize : Boolean) : Handle;
		Function TCicn.ReturnBytes : LongInt;
		Procedure TCicn.Free; OVERRIDE;
		Procedure TCicn.ReadCicn(index : Integer);
		Function TCicn.ReturnFrame : Rect;
		{$IFC qDebug}
			Procedure TCicn.Fields(Procedure DoToField(fieldName : Str255;
														fieldAddr : Ptr; fieldType : Integer)); OVERRIDE;
		{$ENDC}
	End;

{==============================}
	TOffScreenPixMap = OBJECT(TObject)
		fBits : Ptr;
		fCGrafPtr : CGrafPtr;
		fGDevice : GDHandle;
		fSize : LongInt;

		Procedure TOffScreenPixMap.IOffScreenPixMap(theDepth : Integer);
		Procedure TOffScreenPixMap.Free; OVERRIDE;

		{$IFC qDebug}
			Procedure TOffScreenPixMap.Fields(Procedure DoToField(fieldName : Str255;
															fieldAddr : Ptr; fieldType : Integer)); OVERRIDE;
		{$ENDC}
	End;
IMPLEMENTATION

{$I UCicn.inc1.p}

End.